Subject: Re: [RFC] fs: add userspace critical mounts event support

From: Johannes Berg <[email-masked]>
Date: Wed, 30 Nov 2016 09:18:29 +0100

On Tue, 2016-11-29 at 22:37 +0100, Luis R. Rodriguez wrote:
> On Tue, Nov 29, 2016 at 10:10:56PM +0100, Tom Gundersen wrote:
> > 
> > On Tue, Nov 15, 2016 at 10:28 AM, Johannes Berg
> > <[email-masked]> wrote:
> > > 
> > > My argument basically goes like this:
> > > 
> > > First, given good drivers (i.e. using request_firmware_nowait())
> > > putting firmware even for a built-in driver into initramfs or not
> > > should be a system integrator decision. If they don't need the
> > > device
> > > that early, it should be possible for them to delay it. Or,
> > > perhaps, if
> > > the firmware is too big, etc. I'm sure we can all come up with
> > > more
> > > examples of why you'd want to do it one way or another.
> > 
> > This is how I understood the the situation, but I never quite
> > bought
> > it. What is wrong with the kernel saying "you must put your module
> > and
> > your firmware together"? Sure, people may want to do things
> > differently, but what is the real blocker?
> 
> 0) Firmware upgrades are possible
> 1) Some firmware is optional
> 2) Firmware licenses may often not be GPLv2 compatible
> 3) Some firmwares may be stupid large (remote-proc) as such
>    neither built-in firmware nor using the firmware in initramfs
>    is reasonable.

4) "firmware" may be on a separate flash partition because it's really
   calibration data required by the (wifi) chip/driver
   (to allow kernel updates without having to taylor the kernel image
   to each and every device!!

johannes